
var inEditing = {};
//var endpoint = 'https://ketepi.pomenapp.com/api/';
var endpoint = 'https://produk.ketengah.gov.my/api/';

function init_app(){
	var storageKediaman = localStorage.getItem('kediaman');
	if (!storageKediaman){
		storageKediaman = [];
	} else {
		storageKediaman = JSON.parse(storageKediaman);
	}
	
	app.kediamanList = storageKediaman;
	app.kediamanMain = storageKediaman;
	
	for (var i in app.kediamanMain){
		if (app.kediamanMain[i].id){
			inEditing[app.kediamanMain[i].id] = true;
		}
	}
}

function check_connection() {
	
	
	
	try {
		var networkState = navigator.connection.type;	
		
		var states = {};
		states[Connection.UNKNOWN]  = 'Unknown connection';
		states[Connection.ETHERNET] = 'Ethernet connection';
		states[Connection.WIFI]     = 'WiFi connection';
		states[Connection.CELL_2G]  = 'Cell 2G connection';
		states[Connection.CELL_3G]  = 'Cell 3G connection';
		states[Connection.CELL_4G]  = 'Cell 4G connection';
		states[Connection.CELL]     = 'Cell generic connection';
		states[Connection.NONE]     = 'No network connection';
		
		var state = states[networkState];
		
	} catch (e){
		var state = window.navigator.onLine ? 'Unknown connection' : 'No network connection';
	}
	//return 'No network connection';
	return state;
}

function validate_token(){
	var token = localStorage.getItem('token');
	
	if (check_connection() == 'No network connection'){
		
		var kampungStat = 0;
		var pendudukStat = 0;
		var kediamanStat = 0;
		
		app.kampung = JSON.parse(localStorage.getItem('kampung'));
		app.user = JSON.parse(localStorage.getItem('user'));
		app.kediamanCloud = JSON.parse(localStorage.getItem('kediaman_cloud'));
		
		var listSearch = [];
		for (var i in app.kediamanCloud){
			app.kediamanCloud[i].kampung = app.kediamanCloud[i].kampung_id;
			if (!inEditing[app.kediamanCloud[i].id]){
				listSearch.push(app.kediamanCloud[i]);
			}
		}
		app.kediamanListSearch = listSearch;
		
		app.showOverlay = false;
		
		
		for (var i in app.kampung) kampungStat++;
		for (var i in app.kediamanCloud){
			kediamanStat++;
			for (var j in app.kediamanCloud.kir){
				pendudukStat++;
			}
			for (var j in app.kediamanCloud.isi_rumah){
				pendudukStat++;
			}

		}
		for (var i in app.kediaman){
			kediamanStat++;
			for (var j in app.kediaman.kir){
				pendudukStat++;
				for (var k in app.kediaman.kir[j].isi_rumah) pendudukStat++;
			}
		}
		
		app.stat_kediaman = kediamanStat;
		app.stat_penduduk = pendudukStat;
		app.stat_kampung = kampungStat;
		
		return;
	}
	
	if (token){
		awan.getJSON(endpoint+'profile', {}, {'Authorization': 'Bearer '+token}).then(function(res){
			
			var kampungStat = 0;
			var pendudukStat = 0;
			var kediamanStat = 0;
			
			app.kediamanCloud = res.kediaman;
			
			var listSearch = [];
			for (var i in app.kediamanCloud){
				app.kediamanCloud[i].kampung = app.kediamanCloud[i].kampung_id;
				listSearch.push(app.kediamanCloud[i]);
			}
			app.kediamanListSearch = listSearch;
			
			var kampung = [];
			for (var i in res.kampung){
				kampung[res.kampung[i].id] = res.kampung[i];
			}
			
			
			
			app.kampung = kampung;
			app.user = res.user;
			app.showOverlay = false;
			
			save_kampung();
			save_user();
			save_kediaman_cloud();
			
			
			
			for (var i in app.kampung) kampungStat++;
			for (var i in app.kediamanCloud){
				kediamanStat++;
					

				
				
				for (var j in app.kediamanCloud[i].kir){
					pendudukStat++;
					
					
					for (var k in app.kediamanCloud[i].kir[j].isi_rumah) pendudukStat++;
				}
				

				
			}
			for (var i in app.kediaman){
				kediamanStat++;
				for (var j in app.kediaman.kir){
					pendudukStat++;
					for (var k in app.kediaman.kir[j].isi_rumah) pendudukStat++;
				}
			}
			
			app.stat_kediaman = kediamanStat;
			app.stat_penduduk = pendudukStat;
			app.stat_kampung = kampungStat;
			
		}).catch(function(){
			localStorage.setItem('token',null);
			app.showOverlay = false;
		})
	} else {
		app.showOverlay = false;
		
	}
}

function auth(credentials){
	var auth;
	if (credentials){
		auth = credentials;
	} else {
		auth = {
			email: app.loginEmail,
			password: app.loginPwd
		}
		
	}
	
	app.showOverlay = true;
	
	app.loginError = '';
	
	awan.postJSON(endpoint+'login?'+awan.queryString(auth)).then(function(res){
		
		app.loggingIn = false;
		app.showLogin = false;
		
		localStorage.setItem('user', JSON.stringify(auth));
		localStorage.setItem('token', res.token);
		
		validate_token();
		
	}).catch(function(error){
		
		app.loggingIn = false;
		app.showOverlay = false;
		app.loginError = error.response.message;
		
		
		
	})
}

function logout(){
	
	app.loggingOut = true;

	awan.postJSON(endpoint+'logout', {}, {'Authorization': 'Bearer '+localStorage.getItem('token')}).then(function(res){
		app.kediamanCloud = [];
		app.user = { name: ''};
		app.token = {};
		app.showOverlay = false;
		app.loggingOut = false;
		localStorage.setItem('token', '');
	})

}

function search_kediaman(){
	
	app.kediamanList = [];
	app.kediamanListSearch = [];
			
	var search = [];
	var ids = {};
	
	for (var i in app.kediamanMain){
		var k = app.kediamanMain[i];
		
		var addr = (k.alamat_1 + k.alamat_2 + app.kampung[k.kampung].nama_kampung).toLowerCase();
		
		var terms = app.searchTerm.toLowerCase().split(' ');
		
		var ok = true;
		for (var i in terms){
			
			if (addr.indexOf(terms[i].replace(/([.,\s]+)/g,'')) < 0){
				ok = false;
			} 
		}
		
		if (ok){
			if (k.id){
				ids[k.id] = true
			}
			search.push(k);
		}
	}
	
	app.kediamanList = search;
	
	search = [];
	
	for (var i in app.kediamanCloud){
		var k = app.kediamanCloud[i];
		
		var addr = (k.alamat_1 + k.alamat_2+ app.kampung[k.kampung].nama_kampung).toLowerCase();
		
		var terms = app.searchTerm.toLowerCase().split(' ');
		
		var ok = true;
		for (var i in terms){
			
			if (addr.indexOf(terms[i].replace(/([.,\s]+)/g,'')) < 0){
				ok = false;
			} 
		}
		
		if (ok && !ids[k.id]){
			search.push(k);
		}
		
	}
	
	app.kediamanListSearch = search;
	


}

function kediaman_form(){

	for (var id in app.kampung){
		kampung_list[id] = app.kampung[id].nama_kampung;
	}

	app.showBottomNavBar = false; 
	awan.go('#kediaman-form');
	
	var form = document.getElementById('kediaman-form-content');
	form.innerHTML = '<div class="pt-10 w-full text-center"><svg class="mx-auto w-16" version="1.1" id="L4" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"  viewBox="0 0 52 100" enable-background="new 0 0 0 0" xml:space="preserve">  <circle fill="#ccc" stroke="none" cx="6" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite" begin="0.1"/> </circle>  <circle fill="#ccc" stroke="none" cx="26" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite"  begin="0.2"/>    </circle>  <circle fill="#ccc" stroke="none" cx="46" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite"  begin="0.3"/>  </circle></svg></div>';

	
	setTimeout(function(){
		renderForm('kediaman-form-content', sKediaman);
	}, 1000)
}

function exit_kediaman_form(){
	app.showBottomNavBar = true;
	
	awan.go('#kediaman');
	
	document.getElementById('kediaman-form-content').innerHTML = '';
}

function save_kediaman(){
	
	var data = [];
	for (var i in app.kediamanList){
		data.push(app.kediamanList[i]);
	}	
	
	localStorage.setItem('kediaman', JSON.stringify(data));
}

function save_kediaman_cloud(){
	var data = [];
	for (var i in app.kediamanCloud){
		data.push(app.kediamanCloud[i]);
	}	
	
	localStorage.setItem('kediaman_cloud', JSON.stringify(data));
}

function save_kampung(){
	var data =[];
	for (var i in app.kampung){
		data.push(app.kampung[i]);
	}
	localStorage.setItem('kampung', JSON.stringify(data));
}

function save_user(){
	localStorage.setItem('user', JSON.stringify(app.user));
}

function save_kediaman_form(){
	
	if (!app.formOK) return;
		
	app.showBottomNavBar = true; 
	
	var kediaman = formSerialize();	
	var uuid = Date.now() + '-' + Math.random().toString(36).slice(2);
	kediaman['uuid'] = uuid;

	if (app.kediaman){
		idx = app.kediaman.length;
		app.kediamanList[idx] = kediaman;
		
	} else {
		idx = 0;
		app.kediamanList[idx] = kediaman;
	}
	
	var data = [];
	for (var i in app.kediamanList){
		data.push(app.kediamanList[i]);
	}	
	
	localStorage.setItem('kediaman', JSON.stringify(data));
	
	document.getElementById('kediaman-form-content').innerHTML = '';
	app.readCloud = false;
	kediaman_details(idx);
	app.kediamanTab = 'butiran';
}


function kediaman_delete(){
	idx = app.kediamanIdx;
	
	awan.alert({
		title: 'Padam rekod kediaman?',
		message: 'Rekod tidak boleh dikembalikan setelah dipadam',
		buttons: [
			{
				label: 'Padam',
			},
			{
				label: 'Batal'
			}
		]
	}).then(function(res){
		if (res == 'Padam'){
			var data = [];
			for (var i in app.kediamanList){
				if (i != idx) data.push(app.kediamanList[i]);
			}
			
			app.kediamanList = data;
			localStorage.setItem('kediaman', JSON.stringify(data));
			
			awan.go('#kediaman');
			
			app.showBottomNavBar = true;
			
			document.getElementById('kediaman-butiran-form-content').innerHTML = '';
		}
	})
}


function kediaman_details(idx){
	app.kediamanIdx = idx;
	
	if (app.readCloud){
		
		app.kediaman = app.kediamanListSearch[idx];
		for (var i in app.kediaman.kir){
			app.kediaman.kir[i].seq = i;
		}

		kediaman = app.kediamanListSearch[idx];
		
	} else {
		app.kediaman = app.kediamanList[idx];		
		kediaman = app.kediamanList[idx];
	}
	
	app.kediamanTab = 'kediaman';
	but_kediaman = kediaman.but_kediaman ? kediaman.but_kediaman : {};
	
	awan.go('#kediaman-details');
	app.showBottomNavBar = false;
	
	var form = document.getElementById('kediaman-butiran-form-content');
	form.innerHTML = '<div class="pt-10 w-full text-center"><svg class="mx-auto w-16" version="1.1" id="L4" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"  viewBox="0 0 52 100" enable-background="new 0 0 0 0" xml:space="preserve">  <circle fill="#ccc" stroke="none" cx="6" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite" begin="0.1"/> </circle>  <circle fill="#ccc" stroke="none" cx="26" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite"  begin="0.2"/>    </circle>  <circle fill="#ccc" stroke="none" cx="46" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite"  begin="0.3"/>  </circle></svg></div>';

	setTimeout(function(){
		renderForm('kediaman-butiran-form-content',qKediaman, app.readCloud ? app.readCloud : (app.kediaman.id ? true : false));
	},1000)
}

function exit_kediaman_details(){
	awan.go('#kediaman');
	app.showBottomNavBar = true;
	
	if (!app.readCloud){
		app.kediaman.but_kediaman = formSerialize();
		app.kediamanList[app.kediamanIdx] = app.kediaman;
		save_kediaman();
	}
	
	document.getElementById('kediaman-butiran-form-content').innerHTML = '';
}

function leave_details(){
	if (!app.readCloud){
		app.kediaman.but_kediaman = formSerialize();
		app.kediamanList[app.kediamanIdx] = app.kediaman;
		save_kediaman();
	}
	document.getElementById('kediaman-butiran-form-content').innerHTML = '';
	
}

function return_details(){
	var readonly = app.readCloud ? app.readCloud : (app.kediaman.id ?  true : false);
	renderForm('kediaman-butiran-form-content', qKediaman, readonly);
}

function ketua_keluarga_form(idx){
	
	leave_details();
	
	if (idx){
		app.kkIdx = idx;
		kk = app.kediaman.kir[idx];
	} else {
		kk = {};
	}
	
	awan.go('#ketua-keluarga-form');
	
	var form = document.getElementById('ketua-keluarga-form-content');
	form.innerHTML = '<div class="pt-10 w-full text-center"><svg class="mx-auto w-16" version="1.1" id="L4" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"  viewBox="0 0 52 100" enable-background="new 0 0 0 0" xml:space="preserve">  <circle fill="#ccc" stroke="none" cx="6" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite" begin="0.1"/> </circle>  <circle fill="#ccc" stroke="none" cx="26" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite"  begin="0.2"/>    </circle>  <circle fill="#ccc" stroke="none" cx="46" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite"  begin="0.3"/>  </circle></svg></div>';
	
	setTimeout(function(){
		renderForm('ketua-keluarga-form-content', qKK);
	}, 1000)
}

function ketua_keluarga_delete(idx){
	awan.alert({
		title: 'Padam rekod ketua keluarga?',
		message: 'Rekod tidak boleh dikembalikan setelah dipadam',
		buttons: [
			{
				label: 'Padam',
			},
			{
				label: 'Batal'
			}
		]
	}).then(function(res){
		
		if (res == 'Padam'){
			
			var discarded = [];
			for (var i in app.kediaman.kir){
				if (i != idx){
					discarded[i] = app.kediaman.kir[i];
				}
			}
			
			app.kediaman.kir = discarded;
			save_kediaman();
				
		}
	})
}

function exit_ketua_keluarga_form(){
	
	var form = document.getElementById('ketua-keluarga-form-content');
	form.innerHTML = '';
	
	kk = {};
	
	awan.go('#kediaman-details');
	return_details();
}

function save_ketua_keluarga(){
	
	var kk = formSerialize();
	
	if (app.kkIdx){
		kk.seq = app.kkIdx;
		kk.isi_rumah = app.kediaman.kir[app.kkIdx].isi_rumah;
		app.kediaman.kir[app.kkIdx] = kk;
	} else {
		
		if (!app.kediaman.kir){
			kk.seq = 0;
			app.kediaman.kir = [kk];
		} else {
			kk.seq = app.kediaman.kir.length;
			app.kediaman.kir[app.kediaman.kir.length] = kk;
		}
	}
	
	if (!app.readOnly){
		app.kediamanList[app.kediamanIdx] = app.kediaman;
		save_kediaman();
	}
	
	var form = document.getElementById('ketua-keluarga-form-content');
	form.innerHTML = '';
	
	if (app.readCloud){
		app.newItem = true;
		
		
		if (app.kediaman){
			var idx = app.kediaman.length;
			app.kediamanList[idx] = kediaman;
			app.kediamanIdx = idx;
			
		} else {
			idx = 0;
			app.kediamanIdx = idx;
			app.kediamanList[idx] = kediaman;
		}
	}

	kk = {};
	
	awan.go('#kediaman-details');
	return_details();

}

function isi_rumah_form(kkIdx, idx){
	
	leave_details();
	
	app.kkIdx = kkIdx;
	app.irIdx = idx;
	
	if (idx === undefined){
		ir = {};
	} else {
		ir = app.kediaman.kir[kkIdx].isi_rumah[idx];
	}
	
	awan.go('#isi-rumah-form');
		
	var form = document.getElementById('isi-rumah-form-content');
	form.innerHTML = '<div class="pt-10 w-full text-center"><svg class="mx-auto w-16" version="1.1" id="L4" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"  viewBox="0 0 52 100" enable-background="new 0 0 0 0" xml:space="preserve">  <circle fill="#ccc" stroke="none" cx="6" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite" begin="0.1"/> </circle>  <circle fill="#ccc" stroke="none" cx="26" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite"  begin="0.2"/>    </circle>  <circle fill="#ccc" stroke="none" cx="46" cy="50" r="6">    <animate attributeName="opacity" dur="1s" values="0;1;0" repeatCount="indefinite"  begin="0.3"/>  </circle></svg></div>';
	
	setTimeout(function(){
		renderForm('isi-rumah-form-content', qIsiRumah);
	}, 1000)
	
}

function save_isi_rumah(){
	
	var ir = formSerialize();
	
	if (app.irIdx === undefined){
		if (app.kediaman.kir[app.kkIdx].isi_rumah){
			var n = app.kediaman.kir[app.kkIdx].isi_rumah.length;
			app.kediaman.kir[app.kkIdx].isi_rumah[n] = ir;	
		} else {
			app.kediaman.kir[app.kkIdx].isi_rumah = [ir]
		}
	} else {
		app.kediaman.kir[app.kkIdx].isi_rumah[app.irIdx] = ir;	
		
	}
	if (!app.readOnly){
		app.kediamanList[app.kediamanIdx] = app.kediaman;
		save_kediaman();
	}
	
	var form = document.getElementById('isi-rumah-form-content');
	form.innerHTML = '';

	if (app.readCloud){
		app.newItem = true;
		
		if (app.kediaman){
			var idx = app.kediaman.length;
			app.kediamanIdx = idx;
			app.kediamanList[idx] = kediaman;
			
		} else {
			idx = 0;
			app.kediamanIdx = idx;
			app.kediamanList[idx] = kediaman;
		}
	}

	
	awan.go('#kediaman-details');
	return_details();

}


function isi_rumah_delete(kidx, idx){
	awan.alert({
		title: 'Padam rekod isi rumah?',
		message: 'Rekod tidak boleh dikembalikan setelah dipadam',
		buttons: [
			{
				label: 'Padam',
			},
			{
				label: 'Batal'
			}
		]
	}).then(function(res){
		
		if (res == 'Padam'){
			
			var discarded = [];
			for (var i in app.kediaman.kir[kidx].isi_rumah){
				if (i != idx){
					discarded[i] = app.kediaman.kir[kidx].isi_rumah[i];
				}
			}
			
			app.kediaman.kir[kidx].isi_rumah = discarded;
			save_kediaman();
				
		}
	})
}


function exit_isi_rumah_form(){

	
	var form = document.getElementById('isi-rumah-form-content');
	form.innerHTML = '';

	awan.go('#kediaman-details');
	return_details();

}

function push_to_server(idx){
	var token = localStorage.getItem('token');
	var kediaman = app.kediamanList[idx];
	
	var data = { kediaman: JSON.parse(JSON.stringify(kediaman)) };
	
	if (!kediaman.id){
		var latlng = data.kediaman.latlng.split(',');
		data.kediaman.latitude = latlng[0];
		data.kediaman.longitude = latlng[0];
	
	}
	
	if (data.kediaman.kir){
		
		for (var i in data.kediaman.kir){
			data.kediaman.kir[i].agama = data.kediaman.kir[i].agama ? data.kediaman.kir[i].agama : '';
			data.kediaman.kir[i].id = data.kediaman.kir[i].id ? data.kediaman.kir[i].id : '';
			
			if (!data.kediaman.kir[i].isi_rumah){
				data.kediaman.kir[i].isi_rumah = [];
			} else {
				for (var j in data.kediaman.kir[i].isi_rumah){
					data.kediaman.kir[i].isi_rumah[j].agama = data.kediaman.kir[i].isi_rumah[j].agama ? data.kediaman.kir[i].isi_rumah[j].agama : '';
					data.kediaman.kir[i].isi_rumah[j].id = data.kediaman.kir[i].isi_rumah[j].id ? data.kediaman.kir[i].isi_rumah[j].id : ''; 
				}
			}
		}
		
	} else {
		data.kediaman.kir = [];
	}
	
	var rawdata = JSON.stringify(data);

	kediaman.sync = 1;
	
	
	awan.postJSON(endpoint+'save-daftar', rawdata, {'Authorization': 'Bearer '+token}).then(function(res){
		
			kediaman.sync = 2;
			
			var discarded = [];
			for (var i in app.kediamanList){
				if (i != idx){
					discarded[i] = app.kediamanList[i];
				}
			}
			
			app.kediamanList = discarded;
			
			setTimeout(function(){	
				
				save_kediaman();
				
				validate_token()
				
			},1500)
			
		
	
	}).catch(function(){
		kediaman.sync = null;
	})
}